﻿using System;
using System.Diagnostics;
using System.Windows.Input;
using Windows.UI.Xaml.Controls;

namespace Assignment2
{
    public class DeleteCommand : ICommand
    {
        public event EventHandler CanExecuteChanged;
        private MainPageData mpd;

        public DeleteCommand(MainPageData mpd)
        {
            this.mpd = mpd;
        }

        public bool CanExecute(object parameter)
        {
            return (mpd.SelectedNote != null || mpd.NewNote);
        }

        public async void Execute(object parameter)
        {
            ContentDialog deleteAppDialog = new ContentDialog()
            {
                Title = "Delete Note",
                Content = "Are you sure you want to delete this note?",
                PrimaryButtonText = "Delete Note",
                SecondaryButtonText = "Cancel"
            };

            ContentDialogResult result = await deleteAppDialog.ShowAsync();

            if (result == ContentDialogResult.Primary)
            {
                if (mpd.NewNote)
                {
                    mpd.NewNote = true;
                }
                else
                {
                    mpd.DeleteNote(mpd.SelectedNote);
                    //mpd.Notes.Remove(mpd.SelectedNote);
                    mpd.SelectedNote = null;
                }
            }
        }

        public void FireCanExecuteChanged()
        {
            CanExecuteChanged?.Invoke(this, EventArgs.Empty);
        }
            
    }
}