﻿using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Windows.Input;

namespace Assignment2
{
    public class EditCommand : ICommand
    {
        public event EventHandler CanExecuteChanged;
        private MainPageData mpd;

        public EditCommand(MainPageData mpd)
        {
            this.mpd = mpd;
        }

        public bool CanExecute(object parameter)
        {
            return (mpd.DisableEditor && mpd.SelectedNote != null);
        }

        public void Execute(object parameter)
        {
            mpd.DisableEditor = false;
            mpd.EditorIsReadOnly = false;
            FireCanExecuteChanged();
            mpd.SaveCommand.FireCanExecuteChanged();
        }

        public void FireCanExecuteChanged()
        {
            CanExecuteChanged?.Invoke(this, EventArgs.Empty);
        }
            
    }
}