﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Text;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace Assignment2
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        MainPageData mpd;

        public MainPage()
        {
            this.InitializeComponent();
            mpd = (MainPageData)this.DataContext;
        }

        private void menuExitButton_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Exit();
        }

        private void menuAboutButton_Click(object sender, RoutedEventArgs e)
        {
            Frame.Navigate(typeof(AboutPage));

            //ContentDialog aboutAppDialog = new ContentDialog()
            //{
            //    Title = "About this App",
            //    Content = "NoteZeroLocal © 2017 Ryan Brownell.",
            //    PrimaryButtonText = "Ok"
            //};

            //ContentDialogResult result = await aboutAppDialog.ShowAsync();
        }

        private void listView_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ITextDocument document = Editor.Document;
            if (mpd.SelectedNote != null)
            {
                mpd.EditorIsReadOnly = false;
                //document.SetText(TextSetOptions.FormatRtf, "");
                document.SetText(TextSetOptions.FormatRtf, mpd.SelectedNote.Contents);
                mpd.EditorIsReadOnly = true;
                mpd.EditorEnabled = false;
            }
            else
            {
                mpd.EditorIsReadOnly = false;
                document.SetText(TextSetOptions.FormatRtf, "");
                mpd.EditorEnabled = true;
            }
        }

        private void BoldButton_Click(object sender, RoutedEventArgs e)
        {
            Windows.UI.Text.ITextSelection selectedText = Editor.Document.Selection;
            if (selectedText != null)
            {
                Windows.UI.Text.ITextCharacterFormat charFormatting = selectedText.CharacterFormat;
                charFormatting.Bold = Windows.UI.Text.FormatEffect.Toggle;
                selectedText.CharacterFormat = charFormatting;
            }
        }

        private void ItalicButton_Click(object sender, RoutedEventArgs e)
        {
            Windows.UI.Text.ITextSelection selectedText = Editor.Document.Selection;
            if (selectedText != null)
            {
                Windows.UI.Text.ITextCharacterFormat charFormatting = selectedText.CharacterFormat;
                charFormatting.Italic = Windows.UI.Text.FormatEffect.Toggle;
                selectedText.CharacterFormat = charFormatting;
            }
        }

        private void UnderlineButton_Click(object sender, RoutedEventArgs e)
        {
            Windows.UI.Text.ITextSelection selectedText = Editor.Document.Selection;
            if (selectedText != null)
            {
                Windows.UI.Text.ITextCharacterFormat charFormatting = selectedText.CharacterFormat;
                if (charFormatting.Underline == Windows.UI.Text.UnderlineType.None)
                {
                    charFormatting.Underline = Windows.UI.Text.UnderlineType.Single;
                }
                else
                {
                    charFormatting.Underline = Windows.UI.Text.UnderlineType.None;
                }
                selectedText.CharacterFormat = charFormatting;
            }
        }

        private void Editor_TextChanging(RichEditBox sender, RichEditBoxTextChangingEventArgs args)
        {
            ITextDocument document = Editor.Document;
            string contents;
            document.GetText(TextGetOptions.FormatRtf, out contents);
            mpd.Contents = contents;
        }
    }
}
