﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.Storage;

namespace Assignment2
{
    public class Repository
    {
        private static List<NoteModel> allNotesCache;

        public static List<NoteModel> GetAllNotes()
        {
            if (allNotesCache != null)
            {
                return allNotesCache;
            }

            allNotesCache = new List<NoteModel>();

            using (var db = new NoteContext())
            {
                allNotesCache = db.Notes.ToList();
            }

            return allNotesCache;
        }

        public static void SaveNewNote(NoteModel Note)
        {
            using (var db = new NoteContext())
            {
                db.Notes.Add(Note);
                db.SaveChanges();
            }
        }

        public static void SaveExistingNote(NoteModel Note)
        {
            using (var db = new NoteContext())
            {
                db.Notes.Update(Note);
                db.SaveChanges();
            }
        }

        public static void DeleteExistingNote(NoteModel Note)
        {
            using (var db = new NoteContext())
            {
                db.Notes.Remove(Note);
                db.SaveChanges();
            }
        }

        public static void CreateDemoNote()
        {
            NoteModel demoNote = new NoteModel("Hello World", "This note is in the DB! And should be deleteable!");
            using (var db = new NoteContext())
            {
                db.Notes.Add(demoNote);
                db.SaveChanges();
            }
        }
    }
}
