﻿using System;
using System.Windows.Input;
using Windows.UI.Xaml.Controls;

namespace Assignment2
{
    public class SaveCommand : ICommand
    {
        public event EventHandler CanExecuteChanged;
        private MainPageData mpd;

        public SaveCommand(MainPageData mpd)
        {
            this.mpd = mpd;
        }

        public bool CanExecute(object parameter)
        { 
            return (!mpd.DisableEditor);
        }

        public async void Execute(object parameter)
        {
            if (mpd.NewNote)
            {
                NoteTitlePrompt ntp = new NoteTitlePrompt();

                ContentDialogResult result = await ntp.ShowAsync();

                if (result == ContentDialogResult.Primary && !mpd.NoteWithTitleExists(ntp.NewTitle))
                {
                    NoteModel temp = new NoteModel(ntp.NewTitle, mpd.Contents);
                    //mpd.Notes.Add(temp);
                    mpd.SaveNewNote(temp);
                    mpd.SelectedNote = temp;
                    mpd.NewNote = false;
                }
                else
                {
                    ContentDialog NotSavedDialog = new ContentDialog()
                    {
                        Title = "Note Not Saved",
                        Content = "An invalid title was specified for the note. Please try saving again using a unique title.",
                        PrimaryButtonText = "Ok"
                    };

                    ContentDialogResult notSaved = await NotSavedDialog.ShowAsync();
                }
            }
            else
            {
                mpd.SelectedNote.Contents = mpd.Contents;
                Repository.SaveExistingNote(mpd.SelectedNote);
            }
        }

        public void FireCanExecuteChanged()
        {
            CanExecuteChanged?.Invoke(this, EventArgs.Empty);
        }
    }
}